<?php

class views_navigation_plugin_display_extender_views_navigation extends views_plugin_display_extender {

  function option_definition_alter(&$options) {
    $options['views_navigation'] = array(
      'default' => FALSE,
      'translatable' => FALSE,
      'bool' => TRUE,
    );

    $options['views_navigation_cycle'] = array(
      'default' => TRUE,
      'translatable' => FALSE,
      'bool' => TRUE,
    );

    $options['views_navigation_back'] = array(
      'default' => FALSE,
      'translatable' => FALSE,
      'bool' => TRUE,
    );
    return $options;
  }

  function options_form(&$form, &$form_state) {
    switch ($form_state['section']) {
      case 'views_navigation' :
        $form['#title'] .= t('Views navigation');
        $form['views_navigation'] = array(
          '#type' => 'checkbox',
          '#title' => t('Add navigation links on node pages accessed from this view'),
          '#default_value' => $this->display->get_option('views_navigation'),
        );
        $selector = ':input[name="views_navigation"]';
        $states = array('invisible' => array($selector => array('checked' => FALSE)));
        $form['views_navigation_cycle'] = array(
          '#type' => 'checkbox',
          '#title' => t('Cycling navigation (link to the first on the last node)'),
          '#default_value' => $this->display->get_option('views_navigation_cycle'),
          '#states' => $states,
        );
        $form['views_navigation_back'] = array(
          '#type' => 'checkbox',
          '#title' => t('Add a back link on node pages accessed from this view'),
          '#default_value' => $this->display->get_option('views_navigation_back'),
        );
        break;
    }
  }

  function options_submit(&$form, &$form_state) {
    switch ($form_state['section']) {
      case 'views_navigation' :
        $this->display->set_option('views_navigation', $form_state['values']['views_navigation']);
        $this->display->set_option('views_navigation_cycle', $form_state['values']['views_navigation_cycle']);
        $this->display->set_option('views_navigation_back', $form_state['values']['views_navigation_back']);
        break;
    }
  }

  function options_summary(&$categories, &$options) {
    $options['views_navigation'] = array(
      'category' => 'other',
      'title' => t('Views navigation'),
      'desc' => t('Add navigation links on node pages accessed from this view.'),
    );
    if ($this->display->get_option('views_navigation')) {
      if ($this->display->get_option('views_navigation_cycle')) {
        $value = t('Cycling navigation');
      }
      else {
        $value = t('Linear navigation');
      }
      if ($this->display->get_option('views_navigation_back')) {
        $value .= ' + ' . t('Back link');
      }
    }
    else {
      if ($this->display->get_option('views_navigation_back')) {
        $value = t('Back link');
      }
      else {
        $value = t('None');
      }
    }
    $options['views_navigation']['value'] = $value;
  }

}
